### Apply base attributes
execute if score @s es.augslots matches 0 run function essences:augmenttable/vanilla/pointer
execute if score @s es.augslots matches 0 run item modify entity @s weapon.mainhand essences:fight/set_tally

### Socket 3
execute if score @s es.augslots matches 2 run function essences:augmenttable/scav/majoraugpoint
### Sockets 1/2
execute if score @s es.augslots matches 0..1 run function essences:augmenttable/scav/minoraugpoint

### Write the correct attribute slot(s)
execute if data entity @s HandItems[0].tag.AttributeModifiers[{Name:"es.reflexslot"}] run function essences:augmenttable/reflexslot

# Subtract EP
execute if score @p[gamemode=!spectator,distance=..6] es.essence_scav >= @s es.augcost run scoreboard players operation @p[gamemode=!spectator,distance=..6] es.essence_scav -= @s es.augcost
tellraw @p[gamemode=!spectator,distance=..6] ["",{"text":"You spend "},{"score":{"name":"@s","objective":"es.augcost"},"bold":true,"italic":true,"color":"green"},{"text":" Scavenger EP","bold":true,"italic":true,"color":"green"},{"text":" to augment your item.\nYou are left with "},{"score":{"name":"@p[gamemode=!spectator,distance=..6]","objective":"es.essence_scav"},"bold":true,"italic":true,"color":"green"},{"text":" Scavenger EP","bold":true,"italic":true,"color":"green"},{"text":". "}]

# Effects
playsound minecraft:block.anvil.use block @a ~ ~ ~ 0.25 0.9
playsound minecraft:block.azalea_leaves.place player @a ~ ~ ~ 1 0.5
playsound minecraft:entity.fox.bite player @s ~ ~ ~ 1 0.5
particle minecraft:dust_color_transition 0 1 0 1 .5 .5 .5 ~ ~1.05 ~ .25 0 .25 0 50 normal
execute if score @s es.augslots matches 3 run particle minecraft:happy_villager ~ ~1.25 ~ 0.25 0.15 0.25 0 25 normal
execute if score @s es.augslots matches 3 run playsound minecraft:entity.illusioner.mirror_move player @a ~ ~ ~ 1 0.75

# Advancement
advancement grant @p[gamemode=!spectator,distance=..5] only essences:es_augment