### Determine diff to set
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=1}] run scoreboard players set @s es.mobdiff 1
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=2}] run scoreboard players set @s es.mobdiff 2
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=3}] run scoreboard players set @s es.mobdiff 3
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=4}] run scoreboard players set @s es.mobdiff 4
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=5}] run scoreboard players set @s es.mobdiff 5
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=6}] run scoreboard players set @s es.mobdiff 6
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=7}] run scoreboard players set @s es.mobdiff 7
execute if entity @a[gamemode=!spectator,distance=..35,scores={es.activediff=8}] run scoreboard players set @s es.mobdiff 8


### Diff-specific effects
# 2
effect give @s[tag=es.villager,scores={es.mobdiff=2..}] minecraft:regeneration 5 0 true
# 3
# (no unique effects on 3)
# 4
effect give @s[tag=es.creeper,scores={es.mobdiff=4..}] minecraft:nausea 5 0 true
effect give @s[tag=es.creeper,scores={es.mobdiff=4..}] minecraft:blindness 5 0 true
# 5
effect give @s[tag=es.golem,scores={es.mobdiff=5..}] minecraft:speed 5 0 true
# 6
effect give @s[tag=es.hostile,scores={es.mobdiff=6..}] minecraft:regeneration 3 0 true
# 7
effect give @s[tag=es.toughhostile,scores={es.mobdiff=7..}] minecraft:regeneration 3 1 true
effect give @s[tag=es.bosshostile,scores={es.mobdiff=7..}] minecraft:regeneration 5 2 true
# 8
# (no unique effects on 8)

### Ability handling
execute if score rate es.mobabtog matches 0 if entity @a[distance=..35,scores={es.mobmana=1..,es.mobcd=..0}] unless entity @p[gamemode=!spectator,scores={es.activediff=1}] run tag @s[predicate=essences:35percent] add es.ability
scoreboard players add @a[gamemode=!spectator,distance=..35,scores={es.mobmana=..150,es.activediff=5..}] es.mobmana 1
scoreboard players add @a[gamemode=!spectator,distance=..35,scores={es.mobmana=..200,es.activediff=6..}] es.mobmana 1
scoreboard players add @a[gamemode=!spectator,distance=..35,scores={es.mobmana=..300,es.activediff=7..}] es.mobmana 1

# Health
execute as @s[scores={es.mobdiff=1..},tag=!es.custombosshp] unless score @s es.mobdiff = @s es.lastmobdiff run function essences:difficulty/healthscale2

# Speed
execute as @s[tag=es.speedhostile,scores={es.mobdiff=1..}] unless score @s es.mobdiff = @s es.lastmobdiff run function essences:difficulty/speedmanager

# Melee DMG (Projectiles handled elsewhere)
execute as @s[scores={es.mobdiff=1..}] unless score @s es.mobdiff = @s es.lastmobdiff run function essences:difficulty/meleemanager

# Comparison update
execute as @s[scores={es.mobdiff=1..}] store result score @s es.lastmobdiff run scoreboard players get @s es.mobdiff
