### Set the default pose
#data merge entity @s[tag=!rav.defaultpose] {ArmorItems:[{},{},{},{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:410021}}]}
tag @s add rav.defaultpose
#
#
### AI Module - Decides next animation state. MUST be sorted from 'last' to 'first'.
### In this example, 'last' animation state is the Reset state, hence why it appears first. The 'first' animation state is float1, hence why it appears last.
### This order prevents several animation states from being ran on the same game tick.
execute as @s[tag=rav.reset] run function animanager:mobstates/illus/reset
execute as @s[tag=rav.dualcast] run function animanager:mobstates/illus/dualcast
execute as @s[tag=rav.point2] run function animanager:mobstates/illus/spelldecide
execute as @s[tag=rav.point] run function animanager:mobstates/illus/point2
execute as @s[tag=rav.floateither,predicate=animanager:35percent] run function animanager:mobstates/illus/point
execute as @s[tag=rav.float2] run function animanager:mobstates/illus/float1
execute as @s[tag=rav.float1,predicate=animanager:50percent] run function animanager:mobstates/illus/float2
execute as @s[tag=!rav.floateither,tag=!rav.attackstate] run function animanager:mobstates/illus/float1

### Bossbar Radius
execute at @s run bossbar set essences:es.illus players @a[distance=..100]

### Arrow Stuff
execute as @e[type=arrow,tag=es.illusarrow,nbt={inGround:1b}] at @s run function animanager:mobstates/illus/attacks/swarmarrows

### Summons
execute as @e[type=skeleton,tag=es.illussummon] at @s run function animanager:mobstates/illus/attacks/summons

### Dialogue
execute as @s run function animanager:mobstates/illus/dialogue/predialogue
