### UUID Comparison
tag @s add es.arrow.uuidcompare

execute store result score @s es.arrowowner run data get entity @s Owner[3] 1
execute as @a[gamemode=!spectator,distance=..5] if score @s es.uuid = @e[limit=1,sort=nearest,type=arrow,tag=es.arrow.uuidcompare] es.arrowowner run tag @s add es.temp.shooter

tag @s remove es.arrow.uuidcompare
###

tag @s add es.arrow

execute store result score velo1 es.misc run data get entity @s Motion[0] 1000
execute store result score velo2 es.misc run data get entity @s Motion[1] 1000
execute store result score velo3 es.misc run data get entity @s Motion[2] 1000

execute store result score @s es.arrowdamage run data get entity @s damage 1
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=1}] run function essences:arrows/truthbuffs/1
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=5}] run function essences:arrows/truthbuffs/2
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=10}] run function essences:arrows/truthbuffs/3
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=20}] run function essences:arrows/truthbuffs/4
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=35}] run function essences:arrows/truthbuffs/5
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=50}] run function essences:arrows/truthbuffs/6
execute if entity @p[tag=es.temp.shooter,scores={es.fight3owned=50,es.sneaktick=1}] run function essences:player/trucapstone

execute store result score velo1 es.misc run data get entity @s Motion[0] 1000
execute store result score velo2 es.misc run data get entity @s Motion[1] 1000
execute store result score velo3 es.misc run data get entity @s Motion[2] 1000

### Augment stuff
execute if data entity @p[tag=es.temp.shooter,scores={es.guardbreak=667..}] SelectedItem.tag{es_majoraug:unstableconduit} run execute store result entity @s damage double 1.5 run data get entity @s damage 1 
execute store result score math es.arrowdamage run data get entity @s damage
scoreboard players operation math es.arrowdamage *= @p[tag=es.temp.shooter] es.f3aug
execute store result entity @s damage double 0.01 run scoreboard players get math es.arrowdamage
scoreboard players reset math es.arrowdamage

execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{es.bowtag:'es.fbow'}}}] run function essences:arrows/lookups/fbowlookup
execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{es.bowtag:'es.pbow'}}}] run function essences:arrows/lookups/pbowlookup
execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{es.bowtag:'es.sbow'}}}] run function essences:arrows/lookups/sbowlookup
###

execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{es.bowtag:'es.relicbow'}}}] run function essences:arrows/lookups/relicbowlookup
execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{esitemgroup:heirloomwep}}}] run function essences:arrows/lookups/heirloombowlookup
execute if entity @p[tag=es.temp.shooter,nbt={SelectedItem:{tag:{es.bowtag:'es.defiler'}}}] run tag @s add es.snaparrow

### Cross-diff scaling
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=1}] store result entity @s damage double 1 run data get entity @s damage 1.1
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=2}] store result entity @s damage double 1 run data get entity @s damage 1.2
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=3}] store result entity @s damage double 1 run data get entity @s damage 1.3
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=4}] store result entity @s damage double 1 run data get entity @s damage 1.4
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=5}] store result entity @s damage double 1 run data get entity @s damage 1.5
execute if entity @p[tag=es.temp.shooter,scores={es.scaling=6}] store result entity @s damage double 1 run data get entity @s damage 1.6

### Hidden Art: Magical (roughly +0.2x bonus per tier)
execute if entity @p[tag=es.temp.shooter,tag=es.pevent.ha.magic,scores={es.ha.magic.0.time=1..,es.ha.magic.0.type=1}] store result entity @s damage double 1 run data get entity @s damage 1.2
execute if entity @p[tag=es.temp.shooter,tag=es.pevent.ha.magic,scores={es.ha.magic.1.time=1..,es.ha.magic.1.type=1}] store result entity @s damage double 1 run data get entity @s damage 1.1666
execute if entity @p[tag=es.temp.shooter,tag=es.pevent.ha.magic,scores={es.ha.magic.2.time=1..,es.ha.magic.2.type=1}] store result entity @s damage double 1 run data get entity @s damage 1.1429

### Hidden Art: Bow
execute if entity @p[tag=es.temp.shooter,tag=es.pevent.ha.bow] run function essences:player/hiddenart/bowprime

### Hidden Art: Crossbow
execute if entity @p[tag=es.temp.shooter,tag=es.pevent.ha.crossbow] run function essences:player/hiddenart/crossbowprime

#
tag @a[distance=..5] remove es.temp.shooter