### Attribute - Check for a dummy attribute that doesn't do anything - if it's missing, apply imbue attributes
execute as @a store success score @s es.attquery run attribute @s minecraft:generic.attack_damage modifier remove e55e9ce-a774-1-1-1
execute as @a if score @s es.attquery matches 0 as @s run function essences:player/attribute_reap
execute as @a run attribute @s minecraft:generic.attack_damage modifier add e55e9ce-a774-1-1-1 "attquery" 0 add

# Cross-diff scaling and HA:M-Fight focus scaling
execute as @a run function essences:player/scaling/scaling

# T1 Regen - these specific values animate the health bar exactly once to heal one HP/5sec
effect give @a[scores={es.prot2owned=1..,es.hp=..19}] regeneration 1 2 true

# Saturation
effect give @a[scores={es.scav3owned=10..34,es.hunger=..19},predicate=animanager:10percent] saturation 1 0 true
effect give @a[scores={es.scav3owned=35..,es.hunger=..19}] saturation 2 0 true

### Misc:
scoreboard players remove @a[scores={es.diffeptimer=1..}] es.diffeptimer 1

### AFFLICTION
execute as @a[gamemode=!spectator,tag=es.afflicted] run function essences:affliction5s
execute as @a[scores={es.affgive=3..}] run function essences:afflictiongive

### Dragon endermite clear
execute unless entity @e[tag=!smithed.entity,type=ender_dragon] run kill @e[type=endermite,tag=es.summoned]

### Inspection refresh
scoreboard players enable @a es.inspect

### Wisp Summoning
execute if score rate es.spawnwisps matches 0 as @a[gamemode=!spectator] at @s run function essences:custom_mobs/wisps/spawn_attempt

### Villager trade updates (librarians sell channelers, wandering traders sometimes sell Steelsong Brew)
execute as @e[tag=!smithed.entity,tag=!es.chantrade,type=villager,nbt={VillagerData:{profession:"minecraft:librarian"}}] run function essences:channelers/tradeupdate
execute as @e[tag=!smithed.entity,tag=!es.wandering_trader_roll,type=wandering_trader] run function essences:misc/wandering_trader_update

### 5s relics/augments
execute as @a if data entity @s SelectedItem.tag.es_majoraug at @s run function essences:player/5saugmentlookup

### Vanilla boss/spawn only scaling
execute as @e[type=#essences:spawnscalingonly,tag=!smithed.entity,tag=!es.alreadybuff] at @s run function essences:difficulty/spawnonly

schedule function essences:epbonuses 100t replace