Essence RPG "Sunrise" is a Minecraft Java Edition datapack developed by Ravioli/MrMcAwesumz continuously supported and updated for the latest release version of the main game, continuing the legacy of the original version.
It aims to be a partial conversion of vanilla survival, turning the experience into a stat-building RPG.

Official Discord server permalink: https://discord.gg/VuW8YZa 
    -For support, resources, and discussion


To other datapack developers:
-To add your custom mobs to ERPG's personal difficulty system:
    -Give them some tags:
      Enemy buffs
        -es.diff.custom - Required tag. Used to get the mob to trigger the difficulty handling function.
        -es.hostile - Required tag for enemies. Used most commonly in friend-or-foe identification. 
        -es.creeper - Optional tag for creepers. Used to give creepers on diff 4 or higher noxious death clouds.
        -es.speedhostile - Optional tag for enemies. Gives them scaling speed bonuses as difficulty rises.
        -es.toughhostile - Optional tag for enemies. Gives them increased health regeneration on diff 7 or higher.
        -es.bosshostile - Optional tag for enemies. Gives them very good health regeneration on diff 7 or higher and immunizes them against certain knockback effects.
      Modifiers/technical tags
        -es.undead - Is your mob undead? Immunizes mobs against poison, changes how certain items/abilities interact with them (for example, swaps healing with damage)
        -es.ally - Is your mob an ally to the player? Used to include or exclude certain mobs from helpful/harmful effects.
        -es.villager - Provides the mob with slow health regeneration on diff 2 or higher. Also used in some friend-or-foe identification, not recommended to slap on specifically to provide your mob with regen.
        -es.golem - Used only to provide golems with the speed effect on diff 5 or higher. Helps iron golems deal with high difficulty zombies, as zombies have the speedhostile tag.
        -es.shorse - Unused. Previously gave skeleton horses more speed, but this turned out to be a bad idea and was removed.
    Note - I currently do not support mobs with base health higher than 820. If your mob has more, their health will plateau at 4096 on higher difficulties. If this affects you, consider editing your own pack to handle such scenarios. Sorry!
-To add custom ERPG-styled drops to your mobs:
    -Follow the template set in the folder "erpg_creator_template". Inside is a template pack which you can follow the example of to edit your own pack. With this system, your mobs will only drop loot at the *player's* location rather than their own, the new loot will not override vanilla or other custom drops, and this loot will only drop if ERPG is also installed.
    -To help determine what is good loot for your mob(s), some commonly used ERPG loot table calls are:
        -essences:item/common/generichostile - One Fighter EP
        -essences:item/common/genericprotector - One Protector EP
        -essences:item/common/genericfarm - One Scavenger EP
        -essences:item/common/channelerpick - A random Channeler
      -IMPORTANT: To prevent this from causing your pack to output loot table validation errors to the console log, it is recommended to keep a copy of these loot tables in your pack, under your own or their own namespace. If items in the `common` folder are changed, this will be made known in that patch's changelog.
      -To find more ERPG items, just poke around in the "item" folder within essences/loot_tables. Note that some items aren't meant to be called with loot tables! In particular, don't try to generate anything from the "newrelic" subfolder - these are technical items meant to be generated by a complicated function tree, only using the loot table as a starting point. To generate them for real, wait until more instructions are available (The new relics aren't done yet as of 0.0.1.4).